###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Erik Enge <erik@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.1 $

__doc__ = "Documentation string"
__version__ = "0.1.0"

from Globals import HTMLFile
import string

class base_item:
	"Documentation string"

	meta_types = ()

	base_delete = HTMLFile('base_delete', globals())
	base_edit = HTMLFile('base_edit', globals())

	color_id0 = 'lightblue'
	color_body0 = 'white'
	color_body1 = 'lightgrey'
	color_action1 = 'lightblue'
	color_header0 = 'lightyellow'
	color_header1 = '#6699cc'
	color_sequence_even0 = '#cccccc'
	color_sequence_odd0 = '#aeaeae'
	table_cellpadding0 = '1'
	table_cellspacing0 = '1'

	def local_navigation(self, object, REQUEST):
		"Return navigation local to this class."
		
		if len(self.meta_types) != 0:
			block = '<form action="'+str(REQUEST.URL1)+'/" method="GET">\n'
			block = block + '\t<select name=":method">\n'

			for sub_class in self.meta_types:
				block = block + '\t\t<option value="%s">%s</option>\n' % \
						(sub_class['action'], sub_class['name'])
			block = block + '\t</select>\n\t<input type="submit" value=" Add ">\n</form>\n'

		else:
			
			block = ""
			
		block = block + '<p><a href="../base_delete?ids=%s">Delete</a><br>' % object.id
		block = block + '<a href="base_edit">Edit</a></p>' 
		block = block + '<p><a href="/Control_Panel/Products/%s/Help/' % (self.product_name) +	string.lower(object.meta_type)+'.stx">Help</a></p>'

		return block

	def get_properties(self):
		"Return a list of properties for this object."

		return self._properties

	def base_edit_properties(self, REQUEST):
		"Update properties, with a nice redirect."
		
		for property in self._properties:

			exec("self."+str(property['id'])+" = REQUEST."+str(property['id']))

		return REQUEST.RESPONSE.redirect('')


	def navigation(self, object):
		""

		return ""
	

	def footer(self, context):
		""

		return ""
