###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.1 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.SimpleItem
import Products
import base_item
import re

add_message_filter_redirect = HTMLFile('message_filter_add_redirect', globals())
manage_add_message_filter_form = HTMLFile('message_filter_add', globals())


def manage_add_message_filter(self, id, title, header_name='', regexp_rule='',
							  message_container='', REQUEST=None):
    "Add an instance of the message_filter class"

    self._setObject(id, message_filter(id, title, header_name, regexp_rule,
									   message_container))

    if REQUEST is not None:

        return self.manage_main(self, REQUEST)


class message_filter(
	Products.ZCatalog.CatalogAwareness.CatalogAware,
	Persistent,
	Acquisition.Implicit,
	OFS.SimpleItem.SimpleItem,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'MessageFilter'
	icon = 'misc_/GUM/dtmldoc.gif'
	#default_catalog = 'Catalog'

	_properties = (
		{'id':'title', 'type':'string'},
		{'id':'header_name', 'type':'string'},
		{'id':'regexp_rule', 'type':'string'},
		{'id':'message_container', 'type':'string'}
		)


	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('View MessageFilter',
		 ('',)),
		)

	index_html = HTMLFile('message_filter_index', globals())

	base_edit = HTMLFile('message_filter_edit', globals())

	def __init__(self, id, title, header_name, regexp_rule,
				 message_container):
		"Initialize the class instance"

		self.id = id
		self.title = title

		self.header_name = header_name
		self.regexp_rule = regexp_rule
		self.message_container = message_container

		self.link()

		#self.index_object()


	def link(self):
		"""Compiles the regexp_rule."""

		self._regexp_rule = re.compile(
			# We escape the regular expression string.. ?FXME?
			re.escape(self.regexp_rule)) 

		# Should we do this in a more sophisicated way? ?FIXME?
		#self._message_container = self.getParentNode()[self.message_container]


default__class_init__(message_filter)
